const join = require('path').join
const addRoutes = require('./routes/index')

module.exports = function () {
  const g = { // module defaults
    srcDir: 'content',
    layoutDir: 'layouts/content',
    route: '', // no route
    dirs: ['/'],   // all files
    // page opts
    layout: 'default',
    permalink: ':slug',
    isPost: true,
  }

  const config = createConfig(this.options, g)
  const contentLoader = '@nuxtjs/content/lib/loader/index.js'

  this.options.build.loaders.push({
    test: /\.md$/,
    use: [
      { loader: 'vue-loader' },
      { loader: contentLoader, options: { config } }
    ]
  })

  this.extendRoutes(routes => addRoutes(routes, config))
}

function createConfig (opts, g) {
  const config = Object.assign({}, g, opts.content)
  config.srcPath = opts.srcDir
  config.contentPath = join(opts.srcDir, config.srcDir)
  config.g = g
  // `config.dirs` can be an Array but for simplicity we only read it as a 2D Array
  if (!is2DArray(config.dirs)) config.dirs = [config.dirs]
  return config
}

function is2DArray (arr) {
  return Array.isArray(arr[0])
}
